import .connectives
import .leibniz
import .logic
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.match_nat_type : forall (return : Type) , (return) -> ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_match_nat_type_O : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O).
theorem nat.eq_match_nat_type_O : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O)) ((((@nat.axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
axiom nat.axiom_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)).
theorem nat.eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
theorem nat.sym_eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((case_S) (n))) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
def nat.not_zero : (nat.nat) -> Prop := fun (n : nat.nat) , ((((nat.match_nat_type) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (n).
theorem nat.not_eq_O_S : forall (n:nat.nat) , ((connectives.Not) ) ((((logic.eq_) (nat.nat)) ((nat.O) )) (((nat.S) ) (n))) := fun (n : nat.nat) , ((@connectives.nmk) ((((logic.eq_) (nat.nat)) ((nat.O) )) (((nat.S) ) (n)))) (fun (eqOS : (((logic.eq_) (nat.nat)) ((nat.O) )) (((nat.S) ) (n))) , ((((((@nat.eq_match_nat_type_O) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (fun (y : Prop) , y)) (((((((@logic.eq_ind_r) (nat.nat)) (((nat.S) ) (n))) (fun (x : nat.nat) , ((nat.not_zero) ) (x))) (((((((@nat.sym_eq_match_nat_type_S) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (n)) (fun (y : Prop) , y)) (@connectives.I))) ((nat.O) )) (eqOS)))).
